The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Iir Class Reference

STK general infinite impulse response filter class. More...

`#include <Iir.h>`

Inheritance diagram for stk::Iir:

List of all members.

## Public Member Functions
| Iir (void)
| Default constructor creates a zero-order pass-through "filter".
| Iir (std::vector< StkFloat > &bCoefficients, std::vector< StkFloat > &aCoefficients)
| Overloaded constructor which takes filter coefficients.
| ~Iir (void)
| Class destructor.
void | setCoefficients (std::vector< StkFloat > &bCoefficients, std::vector< StkFloat > &aCoefficients, bool clearState=false)
| Set filter coefficients.
void | setNumerator (std::vector< StkFloat > &bCoefficients, bool clearState=false)
| Set numerator coefficients.
void | setDenominator (std::vector< StkFloat > &aCoefficients, bool clearState=false)
| Set denominator coefficients.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK general infinite impulse response filter class.

This class provides a generic digital filter structure that can be used to implement IIR filters. For filters containing only feedforward terms, the Fir class is slightly more efficient.

In particular, this class implements the standard difference equation:

a[0]*y[n] = b[0]*x[n] + ... + b[nb]*x[n-nb] - a[1]*y[n-1] - ... - a[na]*y[n-na]

If a[0] is not equal to 1, the filter coeffcients are normalized by a[0].

The gain parameter is applied at the filter input and does not affect the coefficient values. The default gain value is 1.0. This structure results in one extra multiply per computed sample, but allows easy control of the overall filter gain.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::Iir::Iir | ( | std::vector< StkFloat > & | bCoefficients,
|  | std::vector< StkFloat > & | aCoefficients |
| ) |  |  |

Overloaded constructor which takes filter coefficients.

An StkError can be thrown if either of the coefficient vector sizes is zero, or if the a[0] coefficient is equal to zero.

## Member Function Documentation

void stk::Iir::setCoefficients | ( | std::vector< StkFloat > & | bCoefficients,
|  | std::vector< StkFloat > & | aCoefficients,
|  | bool | clearState = `false` |
| ) |  |  |

Set filter coefficients.

An StkError can be thrown if either of the coefficient vector sizes is zero, or if the a[0] coefficient is equal to zero. If a[0] is not equal to 1, the filter coeffcients are normalized by a[0]. The internal state of the filter is not cleared unless the clearState flag is `true`.

void stk::Iir::setNumerator | ( | std::vector< StkFloat > & | bCoefficients,
|  | bool | clearState = `false` |
| ) |  |  |

Set numerator coefficients.

An StkError can be thrown if coefficient vector is empty. Any previously set denominator coefficients are left unaffected. Note that the default constructor sets the single denominator coefficient a[0] to 1.0. The internal state of the filter is not cleared unless the clearState flag is `true`.

void stk::Iir::setDenominator | ( | std::vector< StkFloat > & | aCoefficients,
|  | bool | clearState = `false` |
| ) |  |  |

Set denominator coefficients.

An StkError can be thrown if the coefficient vector is empty or if the a[0] coefficient is equal to zero. Previously set numerator coefficients are unaffected unless a[0] is not equal to 1, in which case all coeffcients are normalized by a[0]. Note that the default constructor sets the single numerator coefficient b[0] to 1.0. The internal state of the filter is not cleared unless the clearState flag is `true`.

StkFrames & stk::Iir::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00136 {
    00137 #if defined(_STK_DEBUG_)
    00138   if ( channel >= frames.channels() ) {
    00139     oStream_ << "Iir::tick(): channel and StkFrames arguments are incompatible!";
    00140     handleError( StkError::FUNCTION_ARGUMENT );
    00141   }
    00142 #endif
    00143
    00144   StkFloat *samples = &frames[channel];
    00145   unsigned int i, hop = frames.channels();
    00146   for ( unsigned int j=0; j<frames.frames(); j++, samples += hop ) {
    00147     outputs_[0] = 0.0;
    00148     inputs_[0] = gain_ * *samples;
    00149     for ( i=b_.size()-1; i>0; i-- ) {
    00150       outputs_[0] += b_[i] * inputs_[i];
    00151       inputs_[i] = inputs_[i-1];
    00152     }
    00153     outputs_[0] += b_[0] * inputs_[0];
    00154
    00155     for ( i=a_.size()-1; i>0; i-- ) {
    00156       outputs_[0] += -a_[i] * outputs_[i];
    00157       outputs_[i] = outputs_[i-1];
    00158     }
    00159
    00160     *samples = outputs_[0];
    00161   }
    00162
    00163   lastFrame_[0] = *(samples-hop);
    00164   return frames;
    00165 }

StkFrames & stk::Iir::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00168 {
    00169 #if defined(_STK_DEBUG_)
    00170   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00171     oStream_ << "Iir::tick(): channel and StkFrames arguments are incompatible!";
    00172     handleError( StkError::FUNCTION_ARGUMENT );
    00173   }
    00174 #endif
    00175
    00176   StkFloat *iSamples = &iFrames[iChannel];
    00177   StkFloat *oSamples = &oFrames[oChannel];
    00178   unsigned int i, iHop = iFrames.channels(), oHop = oFrames.channels();
    00179   for ( unsigned int j=0; j<iFrames.frames(); j++, iSamples += iHop, oSamples += oHop ) {
    00180     outputs_[0] = 0.0;
    00181     inputs_[0] = gain_ * *iSamples;
    00182     for ( i=b_.size()-1; i>0; i-- ) {
    00183       outputs_[0] += b_[i] * inputs_[i];
    00184       inputs_[i] = inputs_[i-1];
    00185     }
    00186     outputs_[0] += b_[0] * inputs_[0];
    00187
    00188     for ( i=a_.size()-1; i>0; i-- ) {
    00189       outputs_[0] += -a_[i] * outputs_[i];
    00190       outputs_[i] = outputs_[i-1];
    00191     }
    00192
    00193     *oSamples = outputs_[0];
    00194   }
    00195
    00196   lastFrame_[0] = *(oSamples-oHop);
    00197   return iFrames;
    00198 }

The documentation for this class was generated from the following file:

- Iir.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.